Index: /trunk/source/Lib/TLibCommon/TComPic.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComPic.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComPic.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -73,8 +73,6 @@
     m_apcPicYuv[i]      = NULL;
   }
-#if NH_3D_QTLPC
+#if NH_3D
   m_bReduceBitsQTL    = 0;
-#endif
-#if NH_3D_NBDV
   m_iNumDdvCandPics   = 0;
   m_eRapRefList       = REF_PIC_LIST_0;
@@ -100,5 +98,9 @@
 }
 
+#if REDUCED_ENCODER_MEMORY
+Void TComPic::create( const TComSPS &sps, const TComPPS &pps, const Bool bCreateEncoderSourcePicYuv, const Bool bCreateForImmediateReconstruction )
+#else
 Void TComPic::create( const TComSPS &sps, const TComPPS &pps, const Bool bIsVirtual)
+#endif
 {
   destroy();
@@ -111,11 +113,23 @@
   const UInt         uiMaxDepth      = sps.getMaxTotalCUDepth();
 
+#if REDUCED_ENCODER_MEMORY
+  m_picSym.create( sps, pps, uiMaxDepth, bCreateForImmediateReconstruction );
+  if (bCreateEncoderSourcePicYuv)
+#else
   m_picSym.create( sps, pps, uiMaxDepth );
   if (!bIsVirtual)
+#endif
   {
     m_apcPicYuv[PIC_YUV_ORG    ]   = new TComPicYuv;  m_apcPicYuv[PIC_YUV_ORG     ]->create( iWidth, iHeight, chromaFormatIDC, uiMaxCuWidth, uiMaxCuHeight, uiMaxDepth, true );
     m_apcPicYuv[PIC_YUV_TRUE_ORG]  = new TComPicYuv;  m_apcPicYuv[PIC_YUV_TRUE_ORG]->create( iWidth, iHeight, chromaFormatIDC, uiMaxCuWidth, uiMaxCuHeight, uiMaxDepth, true );
   }
+#if REDUCED_ENCODER_MEMORY
+  if (bCreateForImmediateReconstruction)
+  {
+#endif
   m_apcPicYuv[PIC_YUV_REC]  = new TComPicYuv;  m_apcPicYuv[PIC_YUV_REC]->create( iWidth, iHeight, chromaFormatIDC, uiMaxCuWidth, uiMaxCuHeight, uiMaxDepth, true );
+#if REDUCED_ENCODER_MEMORY
+  }
+#endif
 
   // there are no SEI messages associated with this picture initially
@@ -125,17 +139,82 @@
   }
   m_bUsedByCurr = false;
-
-#if H_3D_FCO
-/* initialize the texture to depth reference status */
-  for (int j=0; j<2; j++)
-  {
-      for (int i=0; i<MAX_NUM_REF; i++)
-      {
-          m_aiTexToDepRef[j][i] = -1;
-      }
-  }
-#endif
-
-}
+}
+
+#if REDUCED_ENCODER_MEMORY
+Void TComPic::prepareForEncoderSourcePicYuv()
+{
+  const TComSPS &sps=m_picSym.getSPS();
+
+  const ChromaFormat chromaFormatIDC = sps.getChromaFormatIdc();
+  const Int          iWidth          = sps.getPicWidthInLumaSamples();
+  const Int          iHeight         = sps.getPicHeightInLumaSamples();
+  const UInt         uiMaxCuWidth    = sps.getMaxCUWidth();
+  const UInt         uiMaxCuHeight   = sps.getMaxCUHeight();
+  const UInt         uiMaxDepth      = sps.getMaxTotalCUDepth();
+
+  if (m_apcPicYuv[PIC_YUV_ORG    ]==NULL)
+  {
+    m_apcPicYuv[PIC_YUV_ORG    ]   = new TComPicYuv;  m_apcPicYuv[PIC_YUV_ORG     ]->create( iWidth, iHeight, chromaFormatIDC, uiMaxCuWidth, uiMaxCuHeight, uiMaxDepth, true );
+  }
+  if (m_apcPicYuv[PIC_YUV_TRUE_ORG    ]==NULL)
+  {
+    m_apcPicYuv[PIC_YUV_TRUE_ORG]  = new TComPicYuv;  m_apcPicYuv[PIC_YUV_TRUE_ORG]->create( iWidth, iHeight, chromaFormatIDC, uiMaxCuWidth, uiMaxCuHeight, uiMaxDepth, true );
+  }
+}
+
+Void TComPic::prepareForReconstruction()
+{
+  if (m_apcPicYuv[PIC_YUV_REC] == NULL)
+  {
+    const TComSPS &sps=m_picSym.getSPS();
+    const ChromaFormat chromaFormatIDC = sps.getChromaFormatIdc();
+    const Int          iWidth          = sps.getPicWidthInLumaSamples();
+    const Int          iHeight         = sps.getPicHeightInLumaSamples();
+    const UInt         uiMaxCuWidth    = sps.getMaxCUWidth();
+    const UInt         uiMaxCuHeight   = sps.getMaxCUHeight();
+    const UInt         uiMaxDepth      = sps.getMaxTotalCUDepth();
+
+    m_apcPicYuv[PIC_YUV_REC]  = new TComPicYuv;  m_apcPicYuv[PIC_YUV_REC]->create( iWidth, iHeight, chromaFormatIDC, uiMaxCuWidth, uiMaxCuHeight, uiMaxDepth, true );
+  }
+
+  // mark it should be extended
+  m_apcPicYuv[PIC_YUV_REC]->setBorderExtension(false);
+
+  m_picSym.prepareForReconstruction();
+}
+
+Void TComPic::releaseReconstructionIntermediateData()
+{
+  m_picSym.releaseReconstructionIntermediateData();
+}
+
+Void TComPic::releaseEncoderSourceImageData()
+{
+  if (m_apcPicYuv[PIC_YUV_ORG    ])
+  {
+    m_apcPicYuv[PIC_YUV_ORG]->destroy();
+    delete m_apcPicYuv[PIC_YUV_ORG];
+    m_apcPicYuv[PIC_YUV_ORG] = NULL;
+  }
+  if (m_apcPicYuv[PIC_YUV_TRUE_ORG    ])
+  {
+    m_apcPicYuv[PIC_YUV_TRUE_ORG]->destroy();
+    delete m_apcPicYuv[PIC_YUV_TRUE_ORG];
+    m_apcPicYuv[PIC_YUV_TRUE_ORG] = NULL;
+  }
+}
+
+Void TComPic::releaseAllReconstructionData()
+{
+  if (m_apcPicYuv[PIC_YUV_REC    ])
+  {
+    m_apcPicYuv[PIC_YUV_REC]->destroy();
+    delete m_apcPicYuv[PIC_YUV_REC];
+    m_apcPicYuv[PIC_YUV_REC] = NULL;
+  }
+  m_picSym.releaseAllReconstructionData();
+}
+#endif
+
 
 Void TComPic::destroy()
@@ -156,5 +235,4 @@
 }
 #if NH_3D
-#if NH_3D_ARP
 Void TComPic::getCUAddrAndPartIdx( Int iX, Int iY, Int& riCuAddr, Int& riAbsZorderIdx )
 {
@@ -180,5 +258,4 @@
   riAbsZorderIdx      = g_auiRasterToZscan[ iRastPartIdx ];
 }
-#endif
 Void TComPic::compressMotion(Int scale)
 #else
@@ -343,5 +420,4 @@
 }
 
-#if NH_3D_NBDV 
 Int TComPic::getDisCandRefPictures(Int iColPOC)
 {
@@ -486,32 +562,25 @@
   TComSlice* pcCurrSlice = getSlice(getCurrSliceIdx());
   TComPic* pcTextPic = pcCurrSlice->getIvPic(0, getViewIndex());
-#if H_3D_FCO
-  if ( pcTextPic )
-  {
-#endif
-    TComSlice* pcTextSlice = pcTextPic->getSlice(0); // currently only support single slice
-
-    for(Int iTextRefDir = 0; (iTextRefDir < (pcTextSlice->isInterB() ? 2 :1) ) && !pcTextSlice->isIntra(); iTextRefDir++)
-    {
-      for(Int iTextRefIdx =0; iTextRefIdx < pcTextSlice->getNumRefIdx((RefPicList)iTextRefDir); iTextRefIdx++)
-      {
-        Int iTextRefPOC    = pcTextSlice->getRefPOC((RefPicList)iTextRefDir, iTextRefIdx);
-        Int iTextRefViewId = pcTextSlice->getRefPic((RefPicList)iTextRefDir, iTextRefIdx)->getViewIndex();
-        m_aiTexToDepRef[iTextRefDir][iTextRefIdx] = -1;
-        Int iCurrRefDir = iTextRefDir;
-
-        for(Int iCurrRefIdx = 0; (iCurrRefIdx<pcCurrSlice->getNumRefIdx((RefPicList)iCurrRefDir)) && (m_aiTexToDepRef[iTextRefDir][iTextRefIdx] < 0); iCurrRefIdx++)
-        {
-          if(pcCurrSlice->getRefPOC((RefPicList)iCurrRefDir, iCurrRefIdx ) == iTextRefPOC && 
-            pcCurrSlice->getRefPic((RefPicList)iCurrRefDir, iCurrRefIdx)->getViewIndex() == iTextRefViewId)
-          {  
-            m_aiTexToDepRef[iTextRefDir][iTextRefIdx] = iCurrRefIdx;            
-          }
+  TComSlice* pcTextSlice = pcTextPic->getSlice(0); // currently only support single slice
+
+  for(Int iTextRefDir = 0; (iTextRefDir < (pcTextSlice->isInterB() ? 2 :1) ) && !pcTextSlice->isIntra(); iTextRefDir++)
+  {
+    for(Int iTextRefIdx =0; iTextRefIdx < pcTextSlice->getNumRefIdx((RefPicList)iTextRefDir); iTextRefIdx++)
+    {
+      Int iTextRefPOC    = pcTextSlice->getRefPOC((RefPicList)iTextRefDir, iTextRefIdx);
+      Int iTextRefViewId = pcTextSlice->getRefPic((RefPicList)iTextRefDir, iTextRefIdx)->getViewIndex();
+      m_aiTexToDepRef[iTextRefDir][iTextRefIdx] = -1;
+      Int iCurrRefDir = iTextRefDir;
+
+      for(Int iCurrRefIdx = 0; (iCurrRefIdx<pcCurrSlice->getNumRefIdx((RefPicList)iCurrRefDir)) && (m_aiTexToDepRef[iTextRefDir][iTextRefIdx] < 0); iCurrRefIdx++)
+      {
+        if(pcCurrSlice->getRefPOC((RefPicList)iCurrRefDir, iCurrRefIdx ) == iTextRefPOC && 
+          pcCurrSlice->getRefPic((RefPicList)iCurrRefDir, iCurrRefIdx)->getViewIndex() == iTextRefViewId)
+        {  
+          m_aiTexToDepRef[iTextRefDir][iTextRefIdx] = iCurrRefIdx;            
         }
       }
     }
-#if H_3D_FCO
-  }
-#endif
+  }
 }
 
@@ -520,5 +589,5 @@
   return m_aiTexToDepRef[iTextRefDir][iTextRefIdx];
 }
-#endif
+
 #endif
 
Index: /trunk/source/Lib/TLibCommon/TComPic.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComPic.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComPic.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -159,8 +159,6 @@
   Int**                 m_aaiCodedScale;
   Int**                 m_aaiCodedOffset;
-#if NH_3D_QTLPC
+#if NH_3D
   Bool                  m_bReduceBitsQTL;
-#endif
-#if NH_3D_NBDV
   UInt                   m_uiRapRefIdx;
   RefPicList             m_eRapRefList;
@@ -174,5 +172,14 @@
   virtual ~TComPic();
 
+#if REDUCED_ENCODER_MEMORY
+  Void          create( const TComSPS &sps, const TComPPS &pps, const Bool bCreateEncoderSourcePicYuv, const Bool bCreateForImmediateReconstruction );
+  Void          prepareForEncoderSourcePicYuv();
+  Void          prepareForReconstruction();
+  Void          releaseReconstructionIntermediateData();
+  Void          releaseAllReconstructionData();
+  Void          releaseEncoderSourceImageData();
+#else
   Void          create( const TComSPS &sps, const TComPPS &pps, const Bool bIsVirtual /*= false*/ );
+#endif
 
   virtual Void  destroy();
@@ -245,5 +252,5 @@
    Bool              isTopField()                         {return m_isTop;}
    Void              setField(Bool b)                     {m_isField = b;}
-   Bool              isField()                            {return m_isField;}
+   Bool              isField() const                      {return m_isField;}
 
 #if NH_MV
@@ -325,12 +332,8 @@
    Void          compressMotion(Int scale); 
    Void          printMotion( );
-#if NH_3D_ARP
+#if NH_3D
    Void          getCUAddrAndPartIdx( Int iX, Int iY, Int& riCuAddr, Int& riAbsZorderIdx );
-#endif
-#if NH_3D_QTLPC
    Bool          getReduceBitsFlag ()                     { return m_bReduceBitsQTL;     }
    Void          setReduceBitsFlag ( Bool bFlag )         { m_bReduceBitsQTL = bFlag;    }
-#endif
-#if NH_3D_NBDV
   Int            getNumDdvCandPics()                      { return m_iNumDdvCandPics;    }
   Int            getDisCandRefPictures(Int iColPOC);        
Index: /trunk/source/Lib/TLibCommon/TComPicSym.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComPicSym.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComPicSym.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -64,4 +64,7 @@
 ,m_puiTileIdxMap(NULL)
 ,m_ctuRsToTsAddrMap(NULL)
+#if REDUCED_ENCODER_MEMORY
+,m_dpbPerCtuData(NULL)
+#endif
 ,m_saoBlkParams(NULL)
 #if ADAPTIVE_QP_SELECTION
@@ -77,10 +80,18 @@
 
 
+#if REDUCED_ENCODER_MEMORY
+Void TComPicSym::create  ( const TComSPS &sps, const TComPPS &pps, UInt uiMaxDepth, const Bool bAllocateCtuArray )
+#else
 Void TComPicSym::create  ( const TComSPS &sps, const TComPPS &pps, UInt uiMaxDepth )
-{
+#endif
+{
+  destroy();
+
   m_sps = sps;
   m_pps = pps;
 
+#if !REDUCED_ENCODER_MEMORY
   const ChromaFormat chromaFormatIDC = sps.getChromaFormatIdc();
+#endif
   const Int iPicWidth      = sps.getPicWidthInLumaSamples();
   const Int iPicHeight     = sps.getPicHeightInLumaSamples();
@@ -101,5 +112,9 @@
 
   m_numCtusInFrame     = m_frameWidthInCtus * m_frameHeightInCtus;
+#if REDUCED_ENCODER_MEMORY
+  m_pictureCtuArray    = NULL;
+#else
   m_pictureCtuArray    = new TComDataCU*[m_numCtusInFrame];
+#endif
 
   clearSliceBuffer();
@@ -113,4 +128,10 @@
 #endif
 
+#if REDUCED_ENCODER_MEMORY
+  if (bAllocateCtuArray)
+  {
+    prepareForReconstruction();
+  }
+#else
   for (UInt i=0; i<m_numCtusInFrame ; i++ )
   {
@@ -122,4 +143,5 @@
       );
   }
+#endif
 
   m_ctuTsToRsAddrMap = new UInt[m_numCtusInFrame+1];
@@ -141,8 +163,88 @@
 }
 
+#if REDUCED_ENCODER_MEMORY
+Void TComPicSym::prepareForReconstruction()
+{
+  const ChromaFormat chromaFormatIDC = m_sps.getChromaFormatIdc();
+  const UInt uiMaxCuWidth  = m_sps.getMaxCUWidth();
+  const UInt uiMaxCuHeight = m_sps.getMaxCUHeight();
+  if (m_pictureCtuArray == NULL)
+  {
+    m_pictureCtuArray = new TComDataCU*[m_numCtusInFrame];
+
+    for (UInt i=0; i<m_numCtusInFrame ; i++ )
+    {
+      m_pictureCtuArray[i] = new TComDataCU;
+      m_pictureCtuArray[i]->create( chromaFormatIDC, m_numPartitionsInCtu, uiMaxCuWidth, uiMaxCuHeight, false, uiMaxCuWidth >> m_uhTotalDepth
+#if ADAPTIVE_QP_SELECTION
+        , m_pParentARLBuffer
+#endif
+        );
+    }
+  }
+  if (m_dpbPerCtuData == NULL)
+  {
+    m_dpbPerCtuData = new DPBPerCtuData[m_numCtusInFrame];
+    for(UInt i=0; i<m_numCtusInFrame; i++)
+    {
+      for(Int j=0; j<NUM_REF_PIC_LIST_01; j++)
+      {
+        m_dpbPerCtuData[i].m_CUMvField[j].create( m_numPartitionsInCtu );
+      }
+      m_dpbPerCtuData[i].m_pePredMode = new SChar[m_numPartitionsInCtu];
+      memset(m_dpbPerCtuData[i].m_pePredMode, NUMBER_OF_PREDICTION_MODES, m_numPartitionsInCtu);
+      m_dpbPerCtuData[i].m_pePartSize = new SChar[m_numPartitionsInCtu];
+      memset(m_dpbPerCtuData[i].m_pePartSize, NUMBER_OF_PART_SIZES, m_numPartitionsInCtu);
+      m_dpbPerCtuData[i].m_pSlice=NULL;
+    }
+  }
+}
+
+Void TComPicSym::releaseReconstructionIntermediateData()
+{
+  if (m_pictureCtuArray)
+  {
+    for (Int i = 0; i < m_numCtusInFrame; i++)
+    {
+      if (m_pictureCtuArray[i])
+      {
+        m_pictureCtuArray[i]->destroy();
+        delete m_pictureCtuArray[i];
+        m_pictureCtuArray[i] = NULL;
+      }
+    }
+    delete [] m_pictureCtuArray;
+    m_pictureCtuArray = NULL;
+  }
+}
+
+Void TComPicSym::releaseAllReconstructionData()
+{
+  releaseReconstructionIntermediateData();
+
+  if (m_dpbPerCtuData != NULL)
+  {
+    for(UInt i=0; i<m_numCtusInFrame; i++)
+    {
+      for(Int j=0; j<NUM_REF_PIC_LIST_01; j++)
+      {
+        m_dpbPerCtuData[i].m_CUMvField[j].destroy();
+      }
+      delete [] m_dpbPerCtuData[i].m_pePredMode;
+      delete [] m_dpbPerCtuData[i].m_pePartSize;
+    }
+    delete [] m_dpbPerCtuData;
+    m_dpbPerCtuData=NULL;
+  }
+}
+#endif
+
 Void TComPicSym::destroy()
 {
   clearSliceBuffer();
 
+#if REDUCED_ENCODER_MEMORY
+  releaseAllReconstructionData();
+#else
   if (m_pictureCtuArray)
   {
@@ -159,4 +261,5 @@
   m_pictureCtuArray = NULL;
   }
+#endif
 
   delete [] m_ctuTsToRsAddrMap;
@@ -497,3 +600,21 @@
 {
 }
+
+#if MCTS_ENC_CHECK
+
+Void getTilePosition(const TComDataCU* const pcCU, UInt &tileXPosInCtus, UInt &tileYPosInCtus, UInt &tileWidthtInCtus, UInt &tileHeightInCtus)
+{
+  const UInt       currentTileIdx = pcCU->getPic()->getPicSym()->getTileIdxMap(pcCU->getCtuRsAddr());
+  const TComTile    *pCurrentTile = pcCU->getPic()->getPicSym()->getTComTile(currentTileIdx);
+  const UInt     frameWidthInCtus = pcCU->getPic()->getPicSym()->getFrameWidthInCtus();
+  const UInt firstCtuRsAddrOfTile = pcCU->getPic()->getPicSym()->getTComTile(pcCU->getPic()->getPicSym()->getTileIdxMap(pcCU->getCtuRsAddr()))->getFirstCtuRsAddr();
+
+  tileXPosInCtus = firstCtuRsAddrOfTile % frameWidthInCtus;
+  tileYPosInCtus = firstCtuRsAddrOfTile / frameWidthInCtus;
+  tileWidthtInCtus = pCurrentTile->getTileWidthInCtus();
+  tileHeightInCtus = pCurrentTile->getTileHeightInCtus();
+}
+
+#endif
+
 //! \}
Index: /trunk/source/Lib/TLibCommon/TComPicSym.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComPicSym.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComPicSym.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -106,4 +106,22 @@
   UInt*         m_ctuRsToTsAddrMap;    ///< for a given RS (Raster-Scan) address, returns the TS (Tile-Scan; coding order) address. cf CtbAddrRsToTs in specification.
 
+#if REDUCED_ENCODER_MEMORY
+public:
+  struct DPBPerCtuData
+  {
+    Bool isInter(const UInt absPartAddr)                const { return m_pePredMode[absPartAddr] == MODE_INTER; }
+    PartSize getPartitionSize( const UInt absPartAddr ) const { return static_cast<PartSize>( m_pePartSize[absPartAddr] ); }
+    const TComCUMvField* getCUMvField ( RefPicList e )  const { return &m_CUMvField[e];                  }
+    const TComSlice* getSlice()                         const { return m_pSlice; }
+
+    SChar        * m_pePredMode;
+    SChar        * m_pePartSize;
+    TComCUMvField  m_CUMvField[NUM_REF_PIC_LIST_01];
+    TComSlice    * m_pSlice;
+  };
+
+private:
+  DPBPerCtuData *m_dpbPerCtuData;
+#endif
   SAOBlkParam  *m_saoBlkParams;
 #if ADAPTIVE_QP_SELECTION
@@ -121,5 +139,12 @@
 
 public:
+#if REDUCED_ENCODER_MEMORY
+  Void               create  ( const TComSPS &sps, const TComPPS &pps, UInt uiMaxDepth, const Bool bAllocateCtuArray );
+  Void               prepareForReconstruction();
+  Void               releaseReconstructionIntermediateData();
+  Void               releaseAllReconstructionData();
+#else
   Void               create  ( const TComSPS &sps, const TComPPS &pps, UInt uiMaxDepth );
+#endif
   Void               destroy ();
 
@@ -138,4 +163,9 @@
   const TComSPS&     getSPS()                 const                        { return m_sps; }
   const TComPPS&     getPPS()                 const                        { return m_pps; }
+#if REDUCED_ENCODER_MEMORY
+  Bool                 hasDPBPerCtuData() const                            { return (m_dpbPerCtuData!=0); };
+  DPBPerCtuData&       getDPBPerCtuData(UInt ctuRsAddr)                    { return m_dpbPerCtuData[ctuRsAddr]; }
+  const DPBPerCtuData& getDPBPerCtuData(UInt ctuRsAddr) const              { return m_dpbPerCtuData[ctuRsAddr]; }
+#endif
 
   TComSlice *        swapSliceObject(TComSlice* p, UInt i)                 { p->setSPS(&m_sps); p->setPPS(&m_pps); TComSlice *pTmp=m_apSlices[i];m_apSlices[i] = p; pTmp->setSPS(0); pTmp->setPPS(0); return pTmp; }
@@ -166,4 +196,8 @@
 //! \}
 
+#if MCTS_ENC_CHECK
+Void getTilePosition(const TComDataCU* const pcCU, UInt &tileXPosInCtus, UInt &tileYPosInCtus, UInt &tileWidthtInCtus, UInt &tileHeightInCtus);
+#endif
+
 #endif // __TCOMPICSYM__
 
Index: /trunk/source/Lib/TLibCommon/TComPicYuv.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComPicYuv.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComPicYuv.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -93,5 +93,5 @@
   m_picHeight         = picHeight;
 
-#if NH_3D_IV_MERGE
+#if NH_3D
   m_iCuWidth        = maxCUWidth;
   m_iCuHeight       = maxCUHeight;
@@ -141,5 +141,5 @@
   createWithoutCUInfo(picWidth, picHeight, chromaFormatIDC, bUseMargin, maxCUWidth, maxCUHeight);
 
-#if NH_3D_IV_MERGE
+#if NH_3D
   m_iBaseUnitWidth  = maxCUWidth  >> maxCUDepth;
   m_iBaseUnitHeight = maxCUHeight >> maxCUDepth;
@@ -350,5 +350,5 @@
   fclose(pFile);
 }
-#if NH_3D_IV_MERGE
+#if NH_3D
 Void
 TComPicYuv::getTopLeftSamplePos( Int iCuAddr, Int iAbsZorderIdx, Int& riX, Int& riY )
Index: /trunk/source/Lib/TLibCommon/TComPicYuv.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComPicYuv.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComPicYuv.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -80,5 +80,5 @@
 
   Bool  m_bIsBorderExtended;
-#if NH_3D_IV_MERGE
+#if NH_3D
   Int   m_iBaseUnitWidth;       ///< Width of Base Unit (with maximum depth or minimum size, m_iCuWidth >> Max. Depth)
   Int   m_iBaseUnitHeight;      ///< Height of Base Unit (with maximum depth or minimum size, m_iCuHeight >> Max. Depth)
@@ -189,9 +189,7 @@
 #endif
 #if NH_3D
-#if NH_3D_IV_MERGE
   // sample to block and block to sample conversion
   Void  getTopLeftSamplePos( Int iCuAddr, Int iAbsZorderIdx, Int& riX, Int& riY );
   Void  getCUAddrAndPartIdx( Int iX, Int iY, Int& riCuAddr, Int& riAbsZorderIdx );
-#endif
 #endif
 
Index: /trunk/source/Lib/TLibCommon/TComPicYuvMD5.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComPicYuvMD5.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComPicYuvMD5.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
